#include <windows.h>
#include <stdio.h>

LONG RegTreeLastWriteTime(HKEY hKey, LPCTSTR lpSubKey, FILETIME *lwto)
{
	FILETIME lwtn; //, lwto;
	char buf[MAX_PATH+1];
	HKEY hKeyEnum;
	DWORD dwIdx=0;
	LONG ret;

	//lwto.dwLowDateTime = lwt->dwLowDateTime;
	//lwto.dwHighDateTime = lwt->dwHighDateTime;

	if ((ret=RegOpenKeyEx(hKey, lpSubKey, 0, KEY_QUERY_VALUE |  
			KEY_ENUMERATE_SUB_KEYS, &hKeyEnum)) == ERROR_SUCCESS)
	{
		while (RegEnumKey(hKeyEnum, dwIdx, buf, MAX_PATH+1) == ERROR_SUCCESS)
		{
			RegTreeLastWriteTime(hKeyEnum, buf, lwto);
			++dwIdx;
		}
		
		if ((ret=RegQueryInfoKey(hKeyEnum, NULL, NULL, NULL, NULL, NULL, 
				NULL, NULL, NULL, NULL, NULL, &lwtn)) == ERROR_SUCCESS)
		{
			if (CompareFileTime(&lwtn, lwto) == 1)
			{
				lwto->dwLowDateTime = lwtn.dwLowDateTime;
				lwto->dwHighDateTime = lwtn.dwHighDateTime;
			}
		}

		RegCloseKey(hKeyEnum);
	}
	return ret;
}

void PrintControlSetModificationTime(HKEY hKey, LPCTSTR lpSelect)
{
	char datetime[100], indent[15];
	char buf[MAX_PATH+1];
	DWORD t, l=sizeof(DWORD), v;
	FILETIME lwt;

	wsprintf(datetime, "---");

	lwt.dwLowDateTime=0;
	lwt.dwHighDateTime=0;
	indent[0] = '\0';

	while (lstrlen(indent)+lstrlen(lpSelect) < 15)
	{
		indent[lstrlen(indent)+1] = '\0';
		indent[lstrlen(indent)] = ' ';
	}

	if (RegQueryValueEx(hKey, lpSelect, 0, &t, 
			(unsigned char *)&v, &l) == ERROR_SUCCESS && t == REG_DWORD)
	{
		wsprintf(buf, "SYSTEM\\ControlSet%.3d", v);

		if (RegTreeLastWriteTime(HKEY_LOCAL_MACHINE, buf, &lwt) == ERROR_SUCCESS)
		{
			char ldate[50], ltime[50];
			SYSTEMTIME lwtst;
   
			FileTimeToLocalFileTime(&lwt, &lwt);
			FileTimeToSystemTime(&lwt, &lwtst);

			GetDateFormat(LOCALE_USER_DEFAULT, 0, &lwtst, NULL, ldate, 50);
			GetTimeFormat(LOCALE_USER_DEFAULT, 0, &lwtst, NULL, ltime, 50);

			wsprintf(datetime, "%s %s", ldate, ltime);
		}

		printf("%s%s: %s\n", indent, lpSelect, datetime);
	}
	else
		printf("Error: Could not read %s control set select valule.\n", lpSelect);
}

void help()
{
	printf("LastKnownGood - Copy of last control set that successfully started the system.\n");
	printf("Current - Control set that was used to start the system.\n");
	printf("Failed - Copy of last control set that was failed to start the system.\n");
}

int main(int argc, char **argv)
{
	printf("\nlkgtime 0.4 - Display Last Known Good Time\n");
	printf("Copyright (C) 2009-2011 Pasi Ruokola\n");
	printf("Website - http://koti.mbnet.fi/vaultec/\n\n");
	
	if (argc > 1)
	{
		int i;

		for (i = 1; i < argc; i++)
		{
			if ((argv[i][0] == '-' || 
					argv[i][0] == '/') && 
					argv[i][2] == '\0')
			{
				if (argv[i][1] == '?')
				{
					help();
					break;
				}
			}
		}
	}
	else
    {
		HKEY hKey;

		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\Select", 0, 
				KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS)
		{
			printf("Control set modification times:\n\n");
			PrintControlSetModificationTime(hKey, "LastKnownGood");
			PrintControlSetModificationTime(hKey, "Current");
			PrintControlSetModificationTime(hKey, "Failed");

			RegCloseKey(hKey);
		}
		else
			printf("Error: Could not open control set select key.\n");
    }

	return EXIT_SUCCESS;
}
